---
title: 'ARIA: grid role'
slug: Web/Accessibility/ARIA/Roles/Grid_Role
tags:
  - ARIA
  - HTML
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p><span class="seoSummary">The grid role is for a widget that contains one or more rows of cells. The position of each cell is significant and can be focused using keyboard input.</span></p>

<pre class="brush: html notranslate">&lt;table role="grid" aria-labelledby="id-select-your-seat"&gt;
  &lt;caption id="id-select-your-seat"&gt;Select your seat&lt;/caption&gt;
  &lt;tbody role="presentation"&gt;
    &lt;tr role="presentation"&gt;
      &lt;td&gt;&lt;/td&gt;
      &lt;th&gt;Row A&lt;/th&gt;
      &lt;th&gt;Row B&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Aisle 1&lt;/th&gt;
      &lt;td tabindex="0"&gt;
        &lt;button id="1a" tabindex="-1"&gt;1A&lt;/button&gt;
      &lt;/td&gt;
      &lt;td tabindex="-1"&gt;
        &lt;button id="1b" tabindex="-1"&gt;1B&lt;/button&gt;
      &lt;/td&gt;
      &lt;!-- More Columns --&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Aisle 2&lt;/th&gt;
      &lt;td tabindex="-1"&gt;
        &lt;button id="2a" tabindex="-1"&gt;2A&lt;/button&gt;
      &lt;/td&gt;
      &lt;td tabindex="-1"&gt;
        &lt;button id="2b" tabindex="-1"&gt;2B&lt;/button&gt;
      &lt;/td&gt;
      &lt;!-- More Columns --&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;
</pre>

<h2 id="Description">Description</h2>

<p>A grid widget contains one or more rows with one or more cells of thematically related interactive content. While it does not imply a specific visual presentation, it implies a relationship among elements. <span>Uses </span><span>fall into two categories: presenting tabular information (data grids) and grouping other widgets (layout grids). Even though both data grids and layout grids employ the same ARIA roles, states, and properties, differences in their content and purpose surface factors that are important to consider in keyboard interaction design. See </span><a href="https://www.w3.org/TR/wai-aria-practices-1.2/#grid">ARIA Authoring practices</a> for more details</p>

<p>Cell elements have the role <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">gridcell</a></code>, unless they are a row or column header. Then the elements are <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowheader_Role">rowheader</a></code> and <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role">columnheader</a></code>, respectively. Cell elements need to be owned by elements with a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">row</a></code> role. Rows can be grouped using <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a>s</code>.</p>

<p>If the grid is used as an interactive widget, <a href="#keyboard-use">keyboard</a> interactions need to be implemented.</p>

<h3 id="Associated_ARIA_roles_states_and_properties">Associated ARIA roles, states, and properties</h3>

<h4 id="Roles">Roles</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_Role">treegrid</a> (subclass)</dt>
 <dd>If a grid has columns that can expanded or collapsed, a treegrid can be used.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">row</a></dt>
 <dd>A row inside the grid.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a></dt>
 <dd>A group containing one or multiple <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">row</a>s.</dd>
</dl>

<h4 id="States_and_properties">States and properties</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-level_attribute">aria-level</a></dt>
 <dd>Indicates the hierarchical level of the grid within other structures.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-multiselectable_attribute">aria-multiselectable</a></dt>
 <dd>If <code>aria-</code><code>multiselectable</code> is set to <code>true</code>, multiple items in the grid can be selected. The default value is <code>false</code>.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-readonly_attribute">aria-readonly</a></dt>
 <dd>If the user can navigate the grid but not change the value or values of the grid, the <code>aria-readonly</code> should be set to <code>true</code>. The default value is <code>false</code>.</dd>
</dl>

<div class="note">
<p>For many use cases, an HTML <a href="/en-US/docs/Web/HTML/Element/table">table</a> element is sufficient as it and its elements already include many ARIA roles.</p>
</div>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>When a keyboard user encounters a grid, they navigate the rows and columns using the <kbd>left</kbd>, <kbd>right</kbd>, <kbd>top</kbd> and <kbd>down</kbd> keys. To activate the interactive component, they will use the <kbd>return</kbd> and <kbd>space</kbd> keys.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Key</th>
   <th scope="col">Action</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><kbd>→</kbd></td>
   <td>Moves focus one cell to the right. If focus is on the right-most cell in the row, focus does not move.</td>
  </tr>
  <tr>
   <td><kbd>←</kbd></td>
   <td>Moves focus one cell to the left. If focus is on the left-most cell in the row, focus does not move.</td>
  </tr>
  <tr>
   <td><kbd>↓</kbd></td>
   <td>Moves focus one cell down. If focus is on the bottom cell in the column, focus does not move.</td>
  </tr>
  <tr>
   <td><kbd>↑</kbd></td>
   <td>Moves focus one cell up. If focus is on the top cell in the column, focus does not move.</td>
  </tr>
  <tr>
   <td><kbd>Page Down</kbd></td>
   <td>Moves focus down an author-determined number of rows, typically scrolling so the bottom row in the currently visible set of rows becomes one of the first visible rows. If focus is in the last row of the grid, focus does not move.</td>
  </tr>
  <tr>
   <td><kbd>Page Up</kbd></td>
   <td>Moves focus up an author-determined number of rows, typically scrolling so the top row in the currently visible set of rows becomes one of the last visible rows. If focus is in the first row of the grid, focus does not move.</td>
  </tr>
  <tr>
   <td><kbd>Home</kbd></td>
   <td>Moves focus to the first cell in the row that contains focus.</td>
  </tr>
  <tr>
   <td><kbd>End</kbd></td>
   <td>Moves focus to the last cell in the row that contains focus.</td>
  </tr>
  <tr>
   <td><kbd>ctrl</kbd> + <kbd>Home</kbd></td>
   <td>Moves focus to the first cell in the first row.</td>
  </tr>
  <tr>
   <td><kbd>ctrl</kbd> + <kbd>End</kbd></td>
   <td>Moves focus to the last cell in the last row.</td>
  </tr>
 </tbody>
</table>

<p>If cells, rows, or columns can be selected, the following key combination are commonly used:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Key combination</th>
   <th scope="col">Action</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><kbd>ctrl</kbd> + <kbd>Space</kbd></td>
   <td>Select the column that contains the focus.</td>
  </tr>
  <tr>
   <td><kbd>shift</kbd> + <kbd>Space</kbd></td>
   <td>Selects the row that contains the focus. If the grid includes a column with checkboxes to select rows, this key combination can be used to check that box even if the focus is not on the checkbox.</td>
  </tr>
  <tr>
   <td><kbd>ctrl</kbd> + <kbd>A</kbd></td>
   <td>Selects all cells.</td>
  </tr>
  <tr>
   <td><kbd>shift</kbd> + <kbd>→</kbd></td>
   <td>Extends selection one cell to the right.</td>
  </tr>
  <tr>
   <td><kbd>shift</kbd> + <kbd>←</kbd></td>
   <td>Extends selection one cell to the left.</td>
  </tr>
  <tr>
   <td><kbd>shift</kbd> + <kbd>↓</kbd></td>
   <td>Extends selection one cell down.</td>
  </tr>
  <tr>
   <td><kbd>shift</kbd> + <kbd>↑</kbd></td>
   <td>Extends selection one cell up.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Calendar_example">Calendar example</h3>

<div class="hidden">
<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;table role="grid" aria-labelledby="calendarheader" aria-readonly=true&gt;
  &lt;caption id="calendarheader"&gt;September 2018&lt;/caption&gt;
  &lt;thead role="rowgroup"&gt;
    &lt;tr role="row"&gt;
      &lt;td&gt;&lt;/td&gt;
      &lt;th role="columnheader" aria-label="Sunday"&gt;S&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Monday"&gt;M&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Tuesday"&gt;T&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Wednesday"&gt;W&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Thursday"&gt;T&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Friday"&gt;F&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Saturday"&gt;S&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody role="rowgroup"&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 35&lt;/th&gt;
      &lt;td&gt;26&lt;/td&gt;
      &lt;td&gt;27&lt;/td&gt;
      &lt;td&gt;28&lt;/td&gt;
      &lt;td&gt;29&lt;/td&gt;
      &lt;td&gt;30&lt;/td&gt;
      &lt;td&gt;31&lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;1&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 36&lt;/th&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        2
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        3
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        4
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        5
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        6
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        7
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        8
      &lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 37&lt;/th&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        9
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        10
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        11
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        12
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        13
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        14
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        15
      &lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 38&lt;/th&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        16
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        17
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        18
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        19
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        20
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        21
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        22
      &lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 39&lt;/th&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        23
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        24
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        25
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        26
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        27
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        28
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        29
      &lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 40&lt;/th&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        30
      &lt;/td&gt;
      &lt;td&gt;1&lt;/td&gt;
      &lt;td&gt;2&lt;/td&gt;
      &lt;td&gt;3&lt;/td&gt;
      &lt;td&gt;4&lt;/td&gt;
      &lt;td&gt;5&lt;/td&gt;
      &lt;td&gt;6&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">body {
  margin: 2rem;
  font-family: "Helvetica Neue", sans-serif;
}

table {
  margin: 0;
  border-collapse: collapse;
  font-variant-numeric: tabular-nums;
}

tbody th, tbody td {
  padding: 5px;
}

tbody td {
  border: 1px solid #000;
  text-align: right;
  color: #767676;
}

tbody td[role="gridcell"] {
  color: #000;
}

tbody td[role="gridcell"]:hover, tbody td[role="gridcell"]:focus {
    background-color: #f6f6f6;
    outline: 3px solid blue;
  }
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">var selectables = document.querySelectorAll('table td[role="gridcell"]');

selectables[0].setAttribute('tabindex', 0);

var trs = document.querySelectorAll('table tbody tr'),
    row = 0,
    col = 0,
    maxrow = trs.length - 1,
    maxcol = 0;

Array.prototype.forEach.call(trs, function(gridrow, i){
  Array.prototype.forEach.call(gridrow.querySelectorAll('td'), function(el, i){
    el.dataset.row = row;
    el.dataset.col = col;
    col = col + 1;
  });
  if (col&gt;maxcol) { maxcol = col - 1; }
  col = 0;
  row = row + 1;
});

function moveto(newrow, newcol) {
  var tgt = document.querySelector('[data-row="' + newrow + '"][data-col="' + newcol + '"]');
  if (tgt &amp;&amp; (tgt.getAttribute('role')==='gridcell') ) {
    Array.prototype.forEach.call(document.querySelectorAll('[role=gridcell]'), function(el, i){
      el.setAttribute('tabindex', '-1');
    });
    tgt.setAttribute('tabindex', '0');
    tgt.focus();
    return true;
  } else {
    return false;
  }
}

document.querySelector('table').addEventListener("keydown", function(event) {
  switch (event.key) {
    case "ArrowRight":
      moveto(parseInt(event.target.dataset.row, 10), parseInt(event.target.dataset.col, 10) + 1);
      break;
    case "ArrowLeft":
      moveto(parseInt(event.target.dataset.row, 10), parseInt(event.target.dataset.col, 10) - 1);
      break;
    case "ArrowDown":
      moveto(parseInt(event.target.dataset.row, 10) + 1, parseInt(event.target.dataset.col, 10));
      break;
    case "ArrowUp":
      moveto(parseInt(event.target.dataset.row, 10) - 1, parseInt(event.target.dataset.col, 10));
      break;
    case "Home":
      if (event.ctrlKey) {
        var i = 0;
        var result;
        do {
          var j = 0;
          var result;
          do {
            result = moveto(i, j);
            j++;
          } while (result == false);
          i++;
        } while (result == false);
      } else {
        moveto(parseInt(event.target.dataset.row, 10), 0);
      }
      break;
    case "End":
      if (event.ctrlKey) {
        var i = maxrow;
        var result;
        do {
          var j = maxcol;
          do {
            result = moveto(i, j);
            j--;
          } while (result == false);
          i--;
        } while (result == false);
      } else {
        moveto(parseInt(event.target.dataset.row, 10), document.querySelector('[data-row="' + event.target.dataset.row + '"]:last-of-type').dataset.col);
      }
      break;
    case "PageUp":
      var i = 0;
      var result;
      do {
        result = moveto(i, event.target.dataset.col);
        i++;
      } while (result == false);
      break;
    case "PageDown":
      var i = maxrow;
      var result;
      do {
        result = moveto(i, event.target.dataset.col);
        i--;
      } while (result == false);
      break;
    case "Enter":
      alert(event.target.textContent);
      break;
  }
  event.preventDefault();
});
</pre>
</div>

<p>{{EmbedLiveSample("Calendar_example", "100%", "300")}}</p>

<h4 id="HTML_2">HTML</h4>

<pre class="notranslate">&lt;table role="grid" aria-labelledby="calendarheader"&gt;
  &lt;caption id="calendarheader"&gt;September 2018&lt;/caption&gt;
  &lt;thead role="rowgroup"&gt;
    &lt;tr role="row"&gt;
      &lt;td&gt;&lt;/td&gt;
      &lt;th role="columnheader" aria-label="Sunday"&gt;S&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Monday"&gt;M&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Tuesday"&gt;T&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Wednesday"&gt;W&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Thursday"&gt;T&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Friday"&gt;F&lt;/th&gt;
      &lt;th role="columnheader" aria-label="Saturday"&gt;S&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody role="rowgroup"&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 35&lt;/th&gt;
      &lt;td&gt;26&lt;/td&gt;
      &lt;td&gt;27&lt;/td&gt;
      &lt;td&gt;28&lt;/td&gt;
      &lt;td&gt;29&lt;/td&gt;
      &lt;td&gt;30&lt;/td&gt;
      &lt;td&gt;31&lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;1&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr role="row"&gt;
      &lt;th scope="row" role="rowheader"&gt;Week 36&lt;/th&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        2
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        3
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        4
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        5
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        6
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        7
      &lt;/td&gt;
      &lt;td role="gridcell" tabindex="-1"&gt;
        8
      &lt;/td&gt;
    &lt;/tr&gt;
    &lt;!-- … Additional Rows … --&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">table {
  margin: 0;
  border-collapse: collapse;
  font-variant-numeric: tabular-nums;
}

tbody th, tbody td {
  padding: 5px;
}

tbody td {
  border: 1px solid #000;
  text-align: right;
  color: #767676;
}

tbody td[role="gridcell"] {
  color: #000;
}

tbody td[role="gridcell"]:hover, tbody td[role="gridcell"]:focus {
  background-color: #f6f6f6; outline: 3px solid blue;
}
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="notranslate">var selectables = document.querySelectorAll('table td[role="gridcell"]');

selectables[0].setAttribute('tabindex', 0);

var trs = document.querySelectorAll('table tbody tr'),
    row = 0,
    col = 0,
    maxrow = trs.length - 1,
    maxcol = 0;

Array.prototype.forEach.call(trs, function(gridrow, i){
  Array.prototype.forEach.call(gridrow.querySelectorAll('td'), function(el, i){
    el.dataset.row = row;
    el.dataset.col = col;
    col = col + 1;
  });
  if (col&gt;maxcol) { maxcol = col - 1; }
  col = 0;
  row = row + 1;
});

function moveto(newrow, newcol) {
  var tgt = document.querySelector('[data-row="' + newrow + '"][data-col="' + newcol + '"]');
  if (tgt &amp;&amp; (tgt.getAttribute('role')==='gridcell') ) {
    Array.prototype.forEach.call(document.querySelectorAll('[role=gridcell]'), function(el, i){
      el.setAttribute('tabindex', '-1');
    });
    tgt.setAttribute('tabindex', '0');
    tgt.focus();
    return true;
  } else {
    return false;
  }
}

document.querySelector('table').addEventListener("keydown", function(event) {
  switch (event.key) {
    case "ArrowRight":
      moveto(parseInt(event.target.dataset.row, 10), parseInt(event.target.dataset.col, 10) + 1);
      break;
    case "ArrowLeft":
      moveto(parseInt(event.target.dataset.row, 10), parseInt(event.target.dataset.col, 10) - 1);
      break;
    case "ArrowDown":
      moveto(parseInt(event.target.dataset.row, 10) + 1, parseInt(event.target.dataset.col, 10));
      break;
    case "ArrowUp":
      moveto(parseInt(event.target.dataset.row, 10) - 1, parseInt(event.target.dataset.col, 10));
      break;
    case "Home":
      if (event.ctrlKey) {
        var i = 0;
        var result;
        do {
          var j = 0;
          var result;
          do {
            result = moveto(i, j);
            j++;
          } while (result == false);
          i++;
        } while (result == false);
      } else {
        moveto(parseInt(event.target.dataset.row, 10), 0);
      }
      break;
    case "End":
      if (event.ctrlKey) {
        var i = maxrow;
        var result;
        do {
          var j = maxcol;
          do {
            result = moveto(i, j);
            j--;
          } while (result == false);
          i--;
        } while (result == false);
      } else {
        moveto(parseInt(event.target.dataset.row, 10), document.querySelector('[data-row="' + event.target.dataset.row + '"]:last-of-type').dataset.col);
      }
      break;
    case "PageUp":
      var i = 0;
      var result;
      do {
        result = moveto(i, event.target.dataset.col);
        i++;
      } while (result == false);
      break;
    case "PageDown":
      var i = maxrow;
      var result;
      do {
        result = moveto(i, event.target.dataset.col);
        i--;
      } while (result == false);
      break;
    case "Enter":
      alert(event.target.textContent);
      break;
  }
  event.preventDefault();
});</pre>

<h3 id="More_examples">More examples</h3>

<ul>
 <li><a href="https://www.w3.org/TR/wai-aria-practices-1.1/examples/grid/dataGrids.html">Data Grid Examples</a></li>
 <li><a href="https://www.w3.org/TR/wai-aria-practices/examples/grid/LayoutGrids.html">Layout Grids Examples</a></li>
 <li><a href="https://www.w3.org/WAI/tutorials/tables/">W3C/WAI Tutorial: Tables</a></li>
</ul>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Even if the keyboard use is properly implemented, some users might not be aware that they have to use the arrow keys. Make sure that the functionality and interaction needed can be best achieved using the grid role.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#grid","Role Grid")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#grid","Role Grid")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>TBD</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/composite_Role">ARIA composite role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/table_Role">ARIA table role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/treegrid_Role">ARIA treegrid role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/row_Role">ARIA row role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/rowgroup_Role">ARIA rowgroup role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">ARIA: gridcell role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowheader_Role">ARIA: rowheader role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role">ARIA: columnheader role</a></li>
 <li>HTML table element</li>
 <li>aria-level</li>
 <li>aria-multiselectable</li>
 <li>aria-readonly</li>
</ul>
